import collections
import csv
import time
from collections import OrderedDict

start_time = time.time()

freq_dict = {}
words = {}
characters = "aąbcćdeęfghijklłmnńoópqrsśtuvwxyzźż"

"Pobieramy częstotliwość części wyrazów"
with open('freq.csv', newline='', encoding="utf8") as csvfile:
    reader = csv.DictReader(csvfile)
    for row in reader:
        freq_dict[row['WORD']] = row['FREQ']

"Pobieramy słownik"
with open('slowa.txt', encoding="utf-8") as f:
    words = f.read().splitlines()
words = set(words)

"Zwraca częstotliwość wyrazu. Nie znajdującego się na liście wyrazy mają częstotliwość 1"


def freq(word: str):
    return float(freq_dict.get(word, 1))


"Zwraca TRUE jeśli słowo znajduje się w słowniku"


def exists(word: str):
    return word in words


"Sprawdź poprawność dla 1 modyfikacji"


def check1(word: str):
    out = {}
    corrections = candidates(word)
    for x in corrections:
        if exists(x):
            out[x] = freq(x)
    return out


"Sprawdź poprawność dla 1 i 2 modyfikacji"


def check2(word: str):
    depth1 = candidates(word)
    if not depth1:
        return
    depth2 = []
    out1edit = {}

    for candidate in depth1:
        if exists(candidate):
            out1edit[candidate] = freq(candidate)

    out2edit = {}
    for candidate in depth1:
        edits2 = candidates(candidate)
        if edits2:
            depth2 += edits2

    print(len(depth2) + len(depth1))

    for candidate in depth2:
        if exists(candidate):
            out2edit[candidate] = freq(candidate) / 100

    out2edit.update(out1edit)
    "Sortujemy kandydatów malęjaco po częstotliwości występowania"

    return OrderedDict(sorted(out2edit.items(), reverse=True, key=lambda item: item[1]))


"Zwraca liste słów utworzoną 4 poniższymi operacjami"
"Zamienia, usuwa oraz dodaje litere i przestawia 2 litery"


def candidates(word: str):
    if len(word) < 2 or exists(word):
        return
    ret_words = []
    for x in range(len(word)):
        for y in range(len(characters)):
            "Zamień"
            temp = word[:x] + characters[y] + word[x + 1:]
            ret_words.append(temp)
            "Dodaj"
            temp = word[:x] + characters[y] + word[x:]
            ret_words.append(temp)
        "Usuń"
        temp = word[:x] + word[x + 1:]
        ret_words.append(temp)
        "Przestaw"
        for y in range(len(word)):
            if x <= y:
                t_list = [*word]
                t_list[x] = word[y]
                t_list[y] = word[x]
                temp = ''.join(t_list)
                ret_words.append(temp)

    return ret_words


"Główna funkcja zwraca OrderedDict (kandydat,częstotliwość)"
"Word - słowo do poprawy, ammount_suggested - ilość zwracanych kandydatów, dla 0 zwraca wszystkie"
"single_edits - wymusza generowanie kandydatów z tylko 1 edycji"


def check(word: str, amount_suggested: int = 0, single_edits: bool = False):
    suggestions = check2(word) if not single_edits else check1(word)
    if 0 <= amount_suggested < len(suggestions):
        temp = OrderedDict()
        for k in range(amount_suggested):
            pop = suggestions.popitem(last=False)
            temp.update(OrderedDict([(pop[0], pop[1])]))
        suggestions = temp
    return suggestions


"Test czasowy"
tmp = "aa"
for n in range(2, 2):
    check_time = time.time()
    correct = check(tmp)
    print("Check2 dla", n, "liter: ", (time.time() - check_time), "Sekund\n")
    tmp += 'a'

"Test na przykładach dla 3 sugestii"

txt = {"wogóle", "zprzed", "wziąść", "jusz"}
for test in txt:
    check_time = time.time()
    correct = check(test, amount_suggested=3)
    print("Słowo do sprawdzenie = ", test)
    print(correct)
    print("Check czas = ", (time.time() - check_time), "Sekund\n")

print("Całkowity czas =", (time.time() - start_time), "Sekund\n")
